"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createAsyncContext = createAsyncContext;

var _react = _interopRequireWildcard(require("react"));

var _async = require("@shopify/async");

var _reactIdle = require("@shopify/react-idle");

var _hooks = require("./hooks");

var _types = require("./types");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function createAsyncContext(_ref) {
  var id = _ref.id,
      load = _ref.load;
  var resolver = (0, _async.createResolver)({
    id: id,
    load: load
  });

  var Context = /*#__PURE__*/_react["default"].createContext(null); // Just like a "normal" value returned from `createContext`, rendering
  // the value itself is not supported. This component is just a placeholder
  // to provide a more useful error.


  function Root() {
    throw new Error('Do not attempt to render the result of calling `createAsyncContext()` directly. Render its `.Provider` component instead.');
  }

  function Provider(props) {
    var _useAsync = (0, _hooks.useAsync)(resolver, {
      assets: _types.AssetTiming.Immediate
    }),
        load = _useAsync.load,
        resolved = _useAsync.resolved;

    (0, _react.useEffect)(function () {
      load();
    }, [load]);
    return /*#__PURE__*/_react["default"].createElement(Context.Provider, Object.assign({
      value: resolved
    }, props));
  }

  function Consumer(props) {
    return /*#__PURE__*/_react["default"].createElement(Context.Consumer, props);
  }

  function usePreload() {
    return (0, _hooks.useAsync)(resolver, {
      assets: _types.AssetTiming.NextPage
    }).load;
  }

  function Preload() {
    var preload = usePreload();
    (0, _reactIdle.useIdleCallback)(preload);
    return null;
  }

  function Prefetch() {
    var preload = usePreload();
    (0, _react.useEffect)(function () {
      preload();
    }, [preload]);
    return null;
  }

  var FinalComponent = Root;
  Reflect.defineProperty(FinalComponent, 'resolver', {
    value: resolver,
    writable: false
  });
  Reflect.defineProperty(FinalComponent, 'Provider', {
    value: Provider,
    writable: false
  });
  Reflect.defineProperty(FinalComponent, 'Consumer', {
    value: Consumer,
    writable: false
  });
  Reflect.defineProperty(FinalComponent, 'Context', {
    value: Context,
    writable: false
  });
  Reflect.defineProperty(FinalComponent, 'Preload', {
    value: Preload,
    writable: false
  });
  Reflect.defineProperty(FinalComponent, 'Prefetch', {
    value: Prefetch,
    writable: false
  });
  Reflect.defineProperty(FinalComponent, 'KeepFresh', {
    value: Preload,
    writable: false
  });
  Reflect.defineProperty(FinalComponent, 'usePreload', {
    value: usePreload,
    writable: false
  });
  Reflect.defineProperty(FinalComponent, 'usePrefetch', {
    value: usePreload,
    writable: false
  });
  Reflect.defineProperty(FinalComponent, 'useKeepFresh', {
    value: usePreload,
    writable: false
  });
  return FinalComponent;
}