"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  DeferTiming: true,
  Prefetcher: true,
  PrefetchRoute: true,
  createAsyncComponent: true,
  createAsyncContext: true,
  AsyncAssetContext: true,
  AsyncAssetManager: true,
  PrefetchContext: true,
  PrefetchManager: true
};
Object.defineProperty(exports, "DeferTiming", {
  enumerable: true,
  get: function () {
    return _async.DeferTiming;
  }
});
Object.defineProperty(exports, "Prefetcher", {
  enumerable: true,
  get: function () {
    return _Prefetcher.Prefetcher;
  }
});
Object.defineProperty(exports, "PrefetchRoute", {
  enumerable: true,
  get: function () {
    return _PrefetchRoute.PrefetchRoute;
  }
});
Object.defineProperty(exports, "createAsyncComponent", {
  enumerable: true,
  get: function () {
    return _component.createAsyncComponent;
  }
});
Object.defineProperty(exports, "createAsyncContext", {
  enumerable: true,
  get: function () {
    return _provider.createAsyncContext;
  }
});
Object.defineProperty(exports, "AsyncAssetContext", {
  enumerable: true,
  get: function () {
    return _assets.AsyncAssetContext;
  }
});
Object.defineProperty(exports, "AsyncAssetManager", {
  enumerable: true,
  get: function () {
    return _assets.AsyncAssetManager;
  }
});
Object.defineProperty(exports, "PrefetchContext", {
  enumerable: true,
  get: function () {
    return _prefetch.PrefetchContext;
  }
});
Object.defineProperty(exports, "PrefetchManager", {
  enumerable: true,
  get: function () {
    return _prefetch.PrefetchManager;
  }
});

var _async = require("@shopify/async");

var _types = require("./types");

Object.keys(_types).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _types[key];
    }
  });
});

var _hooks = require("./hooks");

Object.keys(_hooks).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _hooks[key];
    }
  });
});

var _Prefetcher = require("./Prefetcher");

var _PrefetchRoute = require("./PrefetchRoute");

var _component = require("./component");

var _provider = require("./provider");

var _assets = require("./context/assets");

var _prefetch = require("./context/prefetch");