"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createAsyncContext = createAsyncContext;

var _react = _interopRequireWildcard(require("react"));

var _async = require("@shopify/async");

var _reactIdle = require("@shopify/react-idle");

var _hooks = require("./hooks");

var _types = require("./types");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function createAsyncContext({
  id,
  load
}) {
  const resolver = (0, _async.createResolver)({
    id,
    load
  });

  const Context = /*#__PURE__*/_react.default.createContext(null); // Just like a "normal" value returned from `createContext`, rendering
  // the value itself is not supported. This component is just a placeholder
  // to provide a more useful error.


  function Root() {
    throw new Error('Do not attempt to render the result of calling `createAsyncContext()` directly. Render its `.Provider` component instead.');
  }

  function Provider(props) {
    const {
      load,
      resolved
    } = (0, _hooks.useAsync)(resolver, {
      assets: _types.AssetTiming.Immediate
    });
    (0, _react.useEffect)(() => {
      load();
    }, [load]);
    return /*#__PURE__*/_react.default.createElement(Context.Provider, Object.assign({
      value: resolved
    }, props));
  }

  function Consumer(props) {
    return /*#__PURE__*/_react.default.createElement(Context.Consumer, props);
  }

  function usePreload() {
    return (0, _hooks.useAsync)(resolver, {
      assets: _types.AssetTiming.NextPage
    }).load;
  }

  function Preload() {
    const preload = usePreload();
    (0, _reactIdle.useIdleCallback)(preload);
    return null;
  }

  function Prefetch() {
    const preload = usePreload();
    (0, _react.useEffect)(() => {
      preload();
    }, [preload]);
    return null;
  }

  const FinalComponent = Root;
  Reflect.defineProperty(FinalComponent, 'resolver', {
    value: resolver,
    writable: false
  });
  Reflect.defineProperty(FinalComponent, 'Provider', {
    value: Provider,
    writable: false
  });
  Reflect.defineProperty(FinalComponent, 'Consumer', {
    value: Consumer,
    writable: false
  });
  Reflect.defineProperty(FinalComponent, 'Context', {
    value: Context,
    writable: false
  });
  Reflect.defineProperty(FinalComponent, 'Preload', {
    value: Preload,
    writable: false
  });
  Reflect.defineProperty(FinalComponent, 'Prefetch', {
    value: Prefetch,
    writable: false
  });
  Reflect.defineProperty(FinalComponent, 'KeepFresh', {
    value: Preload,
    writable: false
  });
  Reflect.defineProperty(FinalComponent, 'usePreload', {
    value: usePreload,
    writable: false
  });
  Reflect.defineProperty(FinalComponent, 'usePrefetch', {
    value: usePreload,
    writable: false
  });
  Reflect.defineProperty(FinalComponent, 'useKeepFresh', {
    value: usePreload,
    writable: false
  });
  return FinalComponent;
}